/* execlass.h
 * This file belongs to Worker, a filemanager for UNIX/X11.
 * Copyright (C) 2002 Ralf Hoffmann.
 * You can contact me at: ralf.hoffmann@epost.de
 *   or http://www.boomerangsworld.de/worker
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/* $Id: execlass.h,v 1.2 2002/07/08 12:44:03 ralf Exp $ */

#ifndef EXECLASS_H
#define EXECLASS_H

#include "wdefines.h"

class ExeClass
{
public:
  typedef enum { EXECUTE_NORMAL = 0,
                 EXECUTE_TERMINAL,
                 EXECUTE_TERMINAL_WAIT,
                 EXECUTE_SHOW_OUTPUT } execlass_execute_t;
  ExeClass( execlass_execute_t exetype );
  ~ExeClass();
  void addCommand( const char *format, ... );
  void execute();
  char *getOutput();
  char *getOutput( int *return_error );
  int getReturnCode();
  int getReturnCode( int *return_error );
  void cdDir( const char *dir );
  int getLastError();
protected:
  char *tmpfile, *tmpoutput, *tmperror;
  FILE *fp;
  execlass_execute_t type;
  int lasterror;
};

#endif
